//---------------------------------------------------------------------------
/*
	Risa [肳]      alias gg3 [kirikiri-3]
	 stands for "Risa Is a Stagecraft Architecture"
	Copyright (C) 2000 W.Dee <dee@kikyou.info> and contributors

	See details of license at "license.txt"
*/
//---------------------------------------------------------------------------
//! @file
//! @brief WaveZOg/xL[Ǘ
//---------------------------------------------------------------------------
#ifndef WAVESEGMENTH
#define WAVESEGMENTH


#include <deque>


//---------------------------------------------------------------------------
//! @brief ĐZOg
//---------------------------------------------------------------------------
struct tTVPWaveSegment
{
	//! @brief RXgN^
	tTVPWaveSegment(tjs_int64 start, tjs_int64 length)
		{ Start = start; Length = FilteredLength = length; }
	tTVPWaveSegment(tjs_int64 start, tjs_int64 length, tjs_int64 filteredlength)
		{ Start = start; Length = length; FilteredLength = filteredlength; }
	tjs_int64 Start; //!< IWifR[_ł̃ZOg̃X^[gʒu (PCM TvOj[P)
	tjs_int64 Length; //!< IWifR[_ł̃ZOg̒ (PCM TvOj[P)
	tjs_int64 FilteredLength; //!< tB^̒ (PCM TvOj[P)
};
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//! @brief Đx
//---------------------------------------------------------------------------
struct tTVPWaveLabel
{
	//! @brief RXgN^
	tjs_int64 Position; //!< IWifR[_ł̃xʒu (PCM TvOj[P)
	ttstr Name; //!< x
	tjs_int Offset;
		/*!< ItZbg
			@note
			This member will be set in tTVPWaveLoopManager::Render,
			and will contain the sample granule offset from first decoding
			point at call of tTVPWaveLoopManager::Render().
		*/

#ifdef TVP_IN_LOOP_TUNER
	// these are only used by the loop tuner
	tjs_int NameWidth; // display name width
	tjs_int Index; // index
#endif

	struct tSortByPositionFuncObj
	{
		bool operator()(
			const tTVPWaveLabel &lhs,
			const tTVPWaveLabel &rhs) const
		{
			return lhs.Position < rhs.Position;
		}
	};

	struct tSortByOffsetFuncObj
	{
		bool operator()(
			const tTVPWaveLabel &lhs,
			const tTVPWaveLabel &rhs) const
		{
			return lhs.Offset < rhs.Offset;
		}
	};

#ifdef TVP_IN_LOOP_TUNER
	struct tSortByIndexFuncObj
	{
		bool operator()(
			const tTVPWaveLabel &lhs,
			const tTVPWaveLabel &rhs) const
		{
			return lhs.Index < rhs.Index;
		}
	};
#endif

	//! @brief RXgN^
	tTVPWaveLabel()
	{
		Position = 0;
		Offset = 0;
#ifdef TVP_IN_LOOP_TUNER
		NameWidth = 0;
		Index = 0;
#endif
	}

	//! @brief RXgN^
	tTVPWaveLabel(tjs_int64 position, const ttstr & name, tjs_int offset)
		: Position(position), Name(name), Offset(offset)
	{
#ifdef TVP_IN_LOOP_TUNER
		NameWidth = 0;
		Index = 0;
#endif
	}
};
//---------------------------------------------------------------------------
bool inline operator < (const tTVPWaveLabel & lhs, const tTVPWaveLabel & rhs)
{
	return lhs.Position < rhs.Position;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
//! @brief WavẽZOgEx̃L[ǗNX
//---------------------------------------------------------------------------
class tTVPWaveSegmentQueue
{
	// deque ɂ Segments  Labels ̔zB
	// ṕA̔zɑʂ̃f[^邱Ƃ͂܂Ȃ̂
	// vector ŏ\Ȃ̂Ȃ ...
	std::deque<tTVPWaveSegment> Segments; //!< ZOg̔z
	std::deque<tTVPWaveLabel> Labels; //!< x̔z

public:
	//! @brief		eNA
	void Clear();

	//! @brief		ZOg̔z𓾂
	//! @return		ZOg̔z
	const std::deque<tTVPWaveSegment> & GetSegments() const { return Segments; }

	//! @brief		x̔z𓾂
	//! @return		x̔z
	const std::deque<tTVPWaveLabel> & GetLabels() const { return Labels; }

	//! @brief		tTVPWaveSegmentQueueGL[
	//! @param		queue		GL[tTVPWaveSegmentQueueIuWFNg
	void Enqueue(const tTVPWaveSegmentQueue & queue);

	//! @brief		tTVPWaveSegmentGL[
	//! @param		queue		GL[tTVPWaveSegmentIuWFNg
	void Enqueue(const tTVPWaveSegment & segment);

	//! @brief		tTVPWaveLabelGL[
	//! @param		queue		GL[tTVPWaveLabelIuWFNg
	//! @note		Offset ͏CȂ̂Œ
	void Enqueue(const tTVPWaveLabel & Label);

	//! @brief		tTVPWaveSegment̔zGL[
	//! @param		queue		GL[ std::dequeue<tTVPWaveSegment>IuWFNg
	void Enqueue(const std::deque<tTVPWaveSegment> & segments);

	//! @brief		tTVPWaveLabel̔zGL[
	//! @param		queue		GL[ std::dequeue<tTVPWaveLabel>IuWFNg
	void Enqueue(const std::deque<tTVPWaveLabel> & Labels);

	//! @brief		擪w蒷fL[
	//! @param		dest		i[L[(e̓NA)
	//! @param		length		؂o(TvOj[P)
	void Dequeue(tTVPWaveSegmentQueue & dest, tjs_int64 length);

	//! @brief		̃L[̑Ŝ̒𓾂
	//! @return		̃L[̒ (TvOj[P)
	tjs_int64 GetFilteredLength() const;

	//! @brief		̃L[̒ω
	//! @param		new_total_filtered_length VL[̒ (TvOj[P)
	//! @note		L[Segments Ȃǂ̒ Labels̈ʒu͐`Ԃ
	void Scale(tjs_int64 new_total_length);

	//! @brief		tB^ꂽʒufR[hʒu֕ϊs
	//! @param		pos tB^ꂽʒu
	//! @note		fR[hʒu
	tjs_int64 FilteredPositionToDecodePosition(tjs_int64 pos) const;
};
//---------------------------------------------------------------------------

#endif

